<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc -->
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>SharedPoolDataSource (Apache Commons DBCP 2.8.0 API)</title>
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="SharedPoolDataSource (Apache Commons DBCP 2.8.0 API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/SharedPoolDataSource.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/apache/commons/dbcp2/datasources/PerUserPoolDataSourceFactory.html" title="class in org.apache.commons.dbcp2.datasources"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../../org/apache/commons/dbcp2/datasources/SharedPoolDataSourceFactory.html" title="class in org.apache.commons.dbcp2.datasources"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/apache/commons/dbcp2/datasources/SharedPoolDataSource.html" target="_top">Frames</a></li>
<li><a href="SharedPoolDataSource.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#fields.inherited.from.class.org.apache.commons.dbcp2.datasources.InstanceKeyDataSource">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.apache.commons.dbcp2.datasources</div>
<h2 title="Class SharedPoolDataSource" class="title">Class SharedPoolDataSource</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">java.lang.Object</a></li>
<li>
<ul class="inheritance">
<li><a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html" title="class in org.apache.commons.dbcp2.datasources">org.apache.commons.dbcp2.datasources.InstanceKeyDataSource</a></li>
<li>
<ul class="inheritance">
<li>org.apache.commons.dbcp2.datasources.SharedPoolDataSource</li>
</ul>
</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><a href="https://docs.oracle.com/javase/8/docs/api/java/io/Serializable.html?is-external=true" title="class or interface in java.io">Serializable</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/AutoCloseable.html?is-external=true" title="class or interface in java.lang">AutoCloseable</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/Wrapper.html?is-external=true" title="class or interface in java.sql">Wrapper</a>, <a href="https://docs.oracle.com/javase/8/docs/api/javax/naming/Referenceable.html?is-external=true" title="class or interface in javax.naming">Referenceable</a>, <a href="https://docs.oracle.com/javase/8/docs/api/javax/sql/CommonDataSource.html?is-external=true" title="class or interface in javax.sql">CommonDataSource</a>, <a href="https://docs.oracle.com/javase/8/docs/api/javax/sql/DataSource.html?is-external=true" title="class or interface in javax.sql">DataSource</a></dd>
</dl>
<hr>
<br>
<pre>public class <span class="typeNameLabel">SharedPoolDataSource</span>
extends <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html" title="class in org.apache.commons.dbcp2.datasources">InstanceKeyDataSource</a></pre>
<div class="block"><p>
 A pooling <code>DataSource</code> appropriate for deployment within J2EE environment. There are many configuration
 options, most of which are defined in the parent class. All users (based on user name) share a single maximum number
 of Connections in this data source.
 </p>

 <p>
 User passwords can be changed without re-initializing the data source. When a
 <code>getConnection(user name, password)</code> request is processed with a password that is different from those
 used to create connections in the pool associated with <code>user name</code>, an attempt is made to create a new
 connection using the supplied password and if this succeeds, idle connections created using the old password are
 destroyed and new connections are created using the new password.
 </p></div>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>2.0</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../../../../serialized-form.html#org.apache.commons.dbcp2.datasources.SharedPoolDataSource">Serialized Form</a></dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<ul class="blockList">
<li class="blockList"><a name="fields.inherited.from.class.org.apache.commons.dbcp2.datasources.InstanceKeyDataSource">
<!--   -->
</a>
<h3>Fields inherited from class&nbsp;org.apache.commons.dbcp2.datasources.<a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html" title="class in org.apache.commons.dbcp2.datasources">InstanceKeyDataSource</a></h3>
<code><a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#UNKNOWN_TRANSACTIONISOLATION">UNKNOWN_TRANSACTIONISOLATION</a></code></li>
</ul>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/dbcp2/datasources/SharedPoolDataSource.html#SharedPoolDataSource--">SharedPoolDataSource</a></span>()</code>
<div class="block">Default no-argument constructor for Serialization</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/dbcp2/datasources/SharedPoolDataSource.html#close--">close</a></span>()</code>
<div class="block">Closes pool being maintained by this data source.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>protected org.apache.commons.dbcp2.datasources.PooledConnectionManager</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/dbcp2/datasources/SharedPoolDataSource.html#getConnectionManager-org.apache.commons.dbcp2.datasources.UserPassKey-">getConnectionManager</a></span>(org.apache.commons.dbcp2.datasources.UserPassKey&nbsp;upkey)</code>&nbsp;</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/dbcp2/datasources/SharedPoolDataSource.html#getMaxTotal--">getMaxTotal</a></span>()</code>
<div class="block">Gets <a href="https://commons.apache.org/proper/commons-pool/apidocs/org/apache/commons/pool2/impl/BaseGenericObjectPool.html?is-external=true#getMaxTotal--" title="class or interface in org.apache.commons.pool2.impl"><code>BaseGenericObjectPool.getMaxTotal()</code></a> for this pool.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/dbcp2/datasources/SharedPoolDataSource.html#getNumActive--">getNumActive</a></span>()</code>
<div class="block">Gets the number of active connections in the pool.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/dbcp2/datasources/SharedPoolDataSource.html#getNumIdle--">getNumIdle</a></span>()</code>
<div class="block">Gets the number of idle connections in the pool.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>protected org.apache.commons.dbcp2.datasources.PooledConnectionAndInfo</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/dbcp2/datasources/SharedPoolDataSource.html#getPooledConnectionAndInfo-java.lang.String-java.lang.String-">getPooledConnectionAndInfo</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;userName,
                          <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;userPassword)</code>&nbsp;</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/naming/Reference.html?is-external=true" title="class or interface in javax.naming">Reference</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/dbcp2/datasources/SharedPoolDataSource.html#getReference--">getReference</a></span>()</code>
<div class="block">Returns a <code>SharedPoolDataSource</code> <a href="https://docs.oracle.com/javase/8/docs/api/javax/naming/Reference.html?is-external=true" title="class or interface in javax.naming"><code>Reference</code></a>.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/dbcp2/datasources/SharedPoolDataSource.html#setMaxTotal-int-">setMaxTotal</a></span>(int&nbsp;maxTotal)</code>
<div class="block">Sets <a href="https://commons.apache.org/proper/commons-pool/apidocs/org/apache/commons/pool2/impl/BaseGenericObjectPool.html?is-external=true#getMaxTotal--" title="class or interface in org.apache.commons.pool2.impl"><code>BaseGenericObjectPool.getMaxTotal()</code></a> for this pool.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/dbcp2/datasources/SharedPoolDataSource.html#setupDefaults-java.sql.Connection-java.lang.String-">setupDefaults</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/java/sql/Connection.html?is-external=true" title="class or interface in java.sql">Connection</a>&nbsp;connection,
             <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;userName)</code>&nbsp;</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/dbcp2/datasources/SharedPoolDataSource.html#toStringFields-java.lang.StringBuilder-">toStringFields</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/StringBuilder.html?is-external=true" title="class or interface in java.lang">StringBuilder</a>&nbsp;builder)</code>&nbsp;</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.org.apache.commons.dbcp2.datasources.InstanceKeyDataSource">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;org.apache.commons.dbcp2.datasources.<a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html" title="class in org.apache.commons.dbcp2.datasources">InstanceKeyDataSource</a></h3>
<code><a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#assertInitializationAllowed--">assertInitializationAllowed</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getConnection--">getConnection</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getConnection-java.lang.String-java.lang.String-">getConnection</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getConnectionPoolDataSource--">getConnectionPoolDataSource</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getDataSourceName--">getDataSourceName</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getDefaultBlockWhenExhausted--">getDefaultBlockWhenExhausted</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getDefaultEvictionPolicyClassName--">getDefaultEvictionPolicyClassName</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getDefaultLifo--">getDefaultLifo</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getDefaultMaxIdle--">getDefaultMaxIdle</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getDefaultMaxTotal--">getDefaultMaxTotal</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getDefaultMaxWaitMillis--">getDefaultMaxWaitMillis</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getDefaultMinEvictableIdleTimeMillis--">getDefaultMinEvictableIdleTimeMillis</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getDefaultMinIdle--">getDefaultMinIdle</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getDefaultNumTestsPerEvictionRun--">getDefaultNumTestsPerEvictionRun</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getDefaultSoftMinEvictableIdleTimeMillis--">getDefaultSoftMinEvictableIdleTimeMillis</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getDefaultTestOnBorrow--">getDefaultTestOnBorrow</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getDefaultTestOnCreate--">getDefaultTestOnCreate</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getDefaultTestOnReturn--">getDefaultTestOnReturn</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getDefaultTestWhileIdle--">getDefaultTestWhileIdle</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getDefaultTimeBetweenEvictionRunsMillis--">getDefaultTimeBetweenEvictionRunsMillis</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getDefaultTransactionIsolation--">getDefaultTransactionIsolation</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getDescription--">getDescription</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getInstanceKey--">getInstanceKey</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getJndiEnvironment-java.lang.String-">getJndiEnvironment</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getLoginTimeout--">getLoginTimeout</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getLogWriter--">getLogWriter</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getMaxConnLifetimeMillis--">getMaxConnLifetimeMillis</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getParentLogger--">getParentLogger</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getValidationQuery--">getValidationQuery</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getValidationQueryTimeout--">getValidationQueryTimeout</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#isDefaultAutoCommit--">isDefaultAutoCommit</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#isDefaultReadOnly--">isDefaultReadOnly</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#isRollbackAfterValidation--">isRollbackAfterValidation</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#isWrapperFor-java.lang.Class-">isWrapperFor</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setConnectionPoolDataSource-javax.sql.ConnectionPoolDataSource-">setConnectionPoolDataSource</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setDataSourceName-java.lang.String-">setDataSourceName</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setDefaultAutoCommit-java.lang.Boolean-">setDefaultAutoCommit</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setDefaultBlockWhenExhausted-boolean-">setDefaultBlockWhenExhausted</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setDefaultEvictionPolicyClassName-java.lang.String-">setDefaultEvictionPolicyClassName</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setDefaultLifo-boolean-">setDefaultLifo</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setDefaultMaxIdle-int-">setDefaultMaxIdle</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setDefaultMaxTotal-int-">setDefaultMaxTotal</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setDefaultMaxWaitMillis-long-">setDefaultMaxWaitMillis</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setDefaultMinEvictableIdleTimeMillis-long-">setDefaultMinEvictableIdleTimeMillis</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setDefaultMinIdle-int-">setDefaultMinIdle</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setDefaultNumTestsPerEvictionRun-int-">setDefaultNumTestsPerEvictionRun</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setDefaultReadOnly-java.lang.Boolean-">setDefaultReadOnly</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setDefaultSoftMinEvictableIdleTimeMillis-long-">setDefaultSoftMinEvictableIdleTimeMillis</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setDefaultTestOnBorrow-boolean-">setDefaultTestOnBorrow</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setDefaultTestOnCreate-boolean-">setDefaultTestOnCreate</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setDefaultTestOnReturn-boolean-">setDefaultTestOnReturn</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setDefaultTestWhileIdle-boolean-">setDefaultTestWhileIdle</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setDefaultTimeBetweenEvictionRunsMillis-long-">setDefaultTimeBetweenEvictionRunsMillis</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setDefaultTransactionIsolation-int-">setDefaultTransactionIsolation</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setDescription-java.lang.String-">setDescription</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setJndiEnvironment-java.lang.String-java.lang.String-">setJndiEnvironment</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setLoginTimeout-int-">setLoginTimeout</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setLogWriter-java.io.PrintWriter-">setLogWriter</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setMaxConnLifetimeMillis-long-">setMaxConnLifetimeMillis</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setRollbackAfterValidation-boolean-">setRollbackAfterValidation</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setValidationQuery-java.lang.String-">setValidationQuery</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setValidationQueryTimeout-int-">setValidationQueryTimeout</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#testCPDS-java.lang.String-java.lang.String-">testCPDS</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#toString--">toString</a>, <a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#unwrap-java.lang.Class-">unwrap</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></h3>
<code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#clone--" title="class or interface in java.lang">clone</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#equals-java.lang.Object-" title="class or interface in java.lang">equals</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#finalize--" title="class or interface in java.lang">finalize</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#getClass--" title="class or interface in java.lang">getClass</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#hashCode--" title="class or interface in java.lang">hashCode</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#notify--" title="class or interface in java.lang">notify</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#notifyAll--" title="class or interface in java.lang">notifyAll</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait--" title="class or interface in java.lang">wait</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait-long-" title="class or interface in java.lang">wait</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait-long-int-" title="class or interface in java.lang">wait</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="SharedPoolDataSource--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>SharedPoolDataSource</h4>
<pre>public&nbsp;SharedPoolDataSource()</pre>
<div class="block">Default no-argument constructor for Serialization</div>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="close--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>close</h4>
<pre>public&nbsp;void&nbsp;close()
           throws <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Exception.html?is-external=true" title="class or interface in java.lang">Exception</a></pre>
<div class="block">Closes pool being maintained by this data source.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/AutoCloseable.html?is-external=true#close--" title="class or interface in java.lang">close</a></code>&nbsp;in interface&nbsp;<code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/AutoCloseable.html?is-external=true" title="class or interface in java.lang">AutoCloseable</a></code></dd>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#close--">close</a></code>&nbsp;in class&nbsp;<code><a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html" title="class in org.apache.commons.dbcp2.datasources">InstanceKeyDataSource</a></code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Exception.html?is-external=true" title="class or interface in java.lang">Exception</a></code></dd>
</dl>
</li>
</ul>
<a name="getMaxTotal--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMaxTotal</h4>
<pre>public&nbsp;int&nbsp;getMaxTotal()</pre>
<div class="block">Gets <a href="https://commons.apache.org/proper/commons-pool/apidocs/org/apache/commons/pool2/impl/BaseGenericObjectPool.html?is-external=true#getMaxTotal--" title="class or interface in org.apache.commons.pool2.impl"><code>BaseGenericObjectPool.getMaxTotal()</code></a> for this pool.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd><a href="https://commons.apache.org/proper/commons-pool/apidocs/org/apache/commons/pool2/impl/BaseGenericObjectPool.html?is-external=true#getMaxTotal--" title="class or interface in org.apache.commons.pool2.impl"><code>BaseGenericObjectPool.getMaxTotal()</code></a> for this pool.</dd>
</dl>
</li>
</ul>
<a name="setMaxTotal-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setMaxTotal</h4>
<pre>public&nbsp;void&nbsp;setMaxTotal(int&nbsp;maxTotal)</pre>
<div class="block">Sets <a href="https://commons.apache.org/proper/commons-pool/apidocs/org/apache/commons/pool2/impl/BaseGenericObjectPool.html?is-external=true#getMaxTotal--" title="class or interface in org.apache.commons.pool2.impl"><code>BaseGenericObjectPool.getMaxTotal()</code></a> for this pool.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>maxTotal</code> - <a href="https://commons.apache.org/proper/commons-pool/apidocs/org/apache/commons/pool2/impl/BaseGenericObjectPool.html?is-external=true#getMaxTotal--" title="class or interface in org.apache.commons.pool2.impl"><code>BaseGenericObjectPool.getMaxTotal()</code></a> for this pool.</dd>
</dl>
</li>
</ul>
<a name="getNumActive--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getNumActive</h4>
<pre>public&nbsp;int&nbsp;getNumActive()</pre>
<div class="block">Gets the number of active connections in the pool.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The number of active connections in the pool.</dd>
</dl>
</li>
</ul>
<a name="getNumIdle--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getNumIdle</h4>
<pre>public&nbsp;int&nbsp;getNumIdle()</pre>
<div class="block">Gets the number of idle connections in the pool.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The number of idle connections in the pool.</dd>
</dl>
</li>
</ul>
<a name="getPooledConnectionAndInfo-java.lang.String-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getPooledConnectionAndInfo</h4>
<pre>protected&nbsp;org.apache.commons.dbcp2.datasources.PooledConnectionAndInfo&nbsp;getPooledConnectionAndInfo(<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;userName,
                                                                                                  <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;userPassword)
                                                                                           throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getPooledConnectionAndInfo-java.lang.String-java.lang.String-">getPooledConnectionAndInfo</a></code>&nbsp;in class&nbsp;<code><a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html" title="class in org.apache.commons.dbcp2.datasources">InstanceKeyDataSource</a></code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code></dd>
</dl>
</li>
</ul>
<a name="getConnectionManager-org.apache.commons.dbcp2.datasources.UserPassKey-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getConnectionManager</h4>
<pre>protected&nbsp;org.apache.commons.dbcp2.datasources.PooledConnectionManager&nbsp;getConnectionManager(org.apache.commons.dbcp2.datasources.UserPassKey&nbsp;upkey)</pre>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#getConnectionManager-org.apache.commons.dbcp2.datasources.UserPassKey-">getConnectionManager</a></code>&nbsp;in class&nbsp;<code><a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html" title="class in org.apache.commons.dbcp2.datasources">InstanceKeyDataSource</a></code></dd>
</dl>
</li>
</ul>
<a name="getReference--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getReference</h4>
<pre>public&nbsp;<a href="https://docs.oracle.com/javase/8/docs/api/javax/naming/Reference.html?is-external=true" title="class or interface in javax.naming">Reference</a>&nbsp;getReference()
                       throws <a href="https://docs.oracle.com/javase/8/docs/api/javax/naming/NamingException.html?is-external=true" title="class or interface in javax.naming">NamingException</a></pre>
<div class="block">Returns a <code>SharedPoolDataSource</code> <a href="https://docs.oracle.com/javase/8/docs/api/javax/naming/Reference.html?is-external=true" title="class or interface in javax.naming"><code>Reference</code></a>.</div>
<dl>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/naming/NamingException.html?is-external=true" title="class or interface in javax.naming">NamingException</a></code></dd>
</dl>
</li>
</ul>
<a name="setupDefaults-java.sql.Connection-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setupDefaults</h4>
<pre>protected&nbsp;void&nbsp;setupDefaults(<a href="https://docs.oracle.com/javase/8/docs/api/java/sql/Connection.html?is-external=true" title="class or interface in java.sql">Connection</a>&nbsp;connection,
                             <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;userName)
                      throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#setupDefaults-java.sql.Connection-java.lang.String-">setupDefaults</a></code>&nbsp;in class&nbsp;<code><a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html" title="class in org.apache.commons.dbcp2.datasources">InstanceKeyDataSource</a></code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code></dd>
</dl>
</li>
</ul>
<a name="toStringFields-java.lang.StringBuilder-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>toStringFields</h4>
<pre>protected&nbsp;void&nbsp;toStringFields(<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/StringBuilder.html?is-external=true" title="class or interface in java.lang">StringBuilder</a>&nbsp;builder)</pre>
<dl>
<dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html#toStringFields-java.lang.StringBuilder-">toStringFields</a></code>&nbsp;in class&nbsp;<code><a href="../../../../../org/apache/commons/dbcp2/datasources/InstanceKeyDataSource.html" title="class in org.apache.commons.dbcp2.datasources">InstanceKeyDataSource</a></code></dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/SharedPoolDataSource.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/apache/commons/dbcp2/datasources/PerUserPoolDataSourceFactory.html" title="class in org.apache.commons.dbcp2.datasources"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../../org/apache/commons/dbcp2/datasources/SharedPoolDataSourceFactory.html" title="class in org.apache.commons.dbcp2.datasources"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/apache/commons/dbcp2/datasources/SharedPoolDataSource.html" target="_top">Frames</a></li>
<li><a href="SharedPoolDataSource.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#fields.inherited.from.class.org.apache.commons.dbcp2.datasources.InstanceKeyDataSource">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &#169; 2001&#x2013;2020 <a href="https://www.apache.org/">The Apache Software Foundation</a>. All rights reserved.</small></p>
</body>
</html>
